<%= javascript_include_tag 'raphael-min' %>
<%= javascript_include_tag 'g.raphael-min' %>
<%= javascript_include_tag 'g.pie-min' %>
<%= javascript_include_tag 'g.line' %>

<div class="control-bar">
	<span class="button"><%= link_to "Scan", new_scan_path(@workspace), { :class => "scan" } %></span>
	<span class="button"><%= link_to "Import", new_workspace_import_path(@workspace), { :class => "import" } %></span>
	<span class="button"><%= link_to "Nexpose Scan", new_workspace_import_path(@workspace), { :class => "nexpose" } %></span>
	<span class="button"><%= link_to "WebScan", new_webscan_path(@workspace), { :class => "webscan" } %></span>
	<div class="separator"></div>
	<span class="button"><%= link_to "Bruteforce",  workspace_brute_force_guess_index_path(@workspace) + '#quick', { :class => "brute" } %></span>
	<span class="button"><%= link_to "Exploit", new_exploit_path(@workspace), { :class => "exploit" } %></span>
	<div class="separator"></div>
  <% if License.get.supports_social_engineering? %>
	<span class="button"><%= link_to "Campaign", workspace_social_engineering_campaigns_path(@workspace, :show => 0), :class => "new" %></span>
  <% else %>
	<span class="button"><%= link_to "Campaign", workspace_campaigns_path(@workspace, :show => 0), :class => "new" %></span>
  <% end %>
	<div class="separator"></div>
	<span class="button"><%= link_to_remote 'Stop all tasks', {:url => stop_all_tasks_path, :method => :post, :confirm => 'Immediately stop all tasks in all projects?'}, :class => 'cancel', :title => "Stop all tasks" %></span>

	<%= form_tag workspaces_search_path, :method => :get do %>
		<%= hidden_field_tag "workspace_id", @workspace.id %>
		<%= text_field_tag :search, '', :placeholder => "Search", :tabindex => 1 %>
	<% end %>
</div>

<div class="dashboard-title">
	Dashboard

	<div id="dashboard-expander" class="expanded"></div>
</div>

<div class="step" id="dashboard-content">

	<table align="center" width="100%">
	<tr><td align="center">
		<h3>Target System Status</h3>
	</td><td align="center">
		<h3>Operating Systems (Top 5)</h3>
	</td></tr>
	<tr><td align="center">
		<div class="chartBox" id="host_chart"></div>
	</td><td align="center">
		<div class="chartBox" id="os_chart"></div>
	</td></tr>
	<tr><td align="center">
		<br/><h3>Project Activity (24 Hours)</h3>
	</td><td align="center">
		<br/><h3>Network Services (Top 5)</h3>
	</td></tr>
	<tr><td align="center">
		<div class="chartBox" id="activity_chart"></div>
	</td><td align="center">
		<div class="chartBox" id="service_chart"></div>
	</td></tr>
	</table>

</div>

<script>

document.observe("dom:loaded", function() {

var r;
<%
# XXX: The status filter filter doesn't seem to work any more.
# Fix with a tag search later. The url that used to be generated
# was: workspaces/:id/hosts?n=20000&status_filter=3 for shelled, eg,
# but now these params aren't being used, probably due to some JSON
# requirement.
	host_states = {
		"Discovered" => [0, (hosts_path(@workspace)).html_safe],
		"Cracked" =>    [0, (hosts_path(@workspace)).html_safe],
		"Shelled" =>    [0, (hosts_path(@workspace)).html_safe],
		"Looted" =>     [0, (hosts_path(@workspace)).html_safe]
	}
	@workspace.hosts.each do |host|
		case host.status
		when 1; host_states["Discovered"][0] += 1
		when 2; host_states["Cracked"][0] += 1
		when 3; host_states["Shelled"][0] += 1
		when 4; host_states["Looted"][0] += 1
		end
	end
	host_states.reject! {|k,v| v[0].zero?}
%>

<% if @workspace.hosts.size > 0 %>
	r = Raphael(document.getElementById("host_chart"), 400, 100);
	r.g.piechart(50, 50, 50, [ <%= host_states.values.map {|v| v[0]}.join(",") %> ],{
		legend: [ <%= host_states.keys.map {|k| "\"#{host_states[k][0]} - #{k}\""}.join(',').html_safe %> ],
		legendpos: "east",
		href: [ <%= host_states.values.map {|v| "\"#{v[1]}\""}.join(',').html_safe %> ]
	});
<% else %>
	document.getElementById("host_chart").innerHTML = "No host data";
<% end %>

<%
	os_stats = @workspace.hosts.where('hosts.os_name IS NOT NULL').group("hosts.os_name").count
	top_names  = os_stats.keys.sort{|a,b| os_stats[b] <=> os_stats[a] }[0, 5]
	top_values = top_names.map{|name| os_stats[name]}
	os_hash = {}
	top_names.each_with_index { |os,i| os_hash[h(os)] = top_values[i] }
	search_url = "search?workspace_id=#{@workspace.id}&commit=Search&search="
%>

<% unless os_hash.empty? %>
	r = Raphael(document.getElementById("os_chart"), 400, 100);
	r.g.piechart(50, 50, 50, [ <%= os_hash.values.join(",")  %> ],{
		legend: [ <%= os_hash.map {|k,v| "\"#{v} - #{k} \"" }.join(",").html_safe %> ],
		href: [ <%= os_hash.map {|k,v| "\"#{search_url + k}\"" }.join(",").html_safe %> ],
		legendpos: "east"
	});
<% else %>
	document.getElementById("os_chart").innerHTML = "No operating system data";
<% end %>

<%

	service_stats = {}
	@workspace.services.reorder('').where('services.name is not NULL').group(["services.name", "services.port", "services.proto"]).count.each_pair do |k,v|
		service_stats[k.first.upcase + " Services"] = v
	end

	top_names  = service_stats.keys.sort{|a,b| service_stats[b] <=> service_stats[a] }[0, 5]
	top_values = top_names.map{|name| service_stats[name] }
	service_hash = {}
	top_names.each_with_index { |os,i| service_hash[h(os)] = top_values[i] }
	search_url = "search?workspace_id=#{@workspace.id}&commit=Search&search="

%>

<% unless service_hash.empty? %>
	r = Raphael(document.getElementById("service_chart"), 400, 100);
	r.g.piechart(50, 50, 50, [ <%= service_hash.values.join(",")  %> ],{
		legend: [ <%=service_hash.map {|k,v| "\"#{v} - #{k} \"" }.join(",").html_safe %> ],
		href: [ <%= service_hash.map {|k,v| "\"#{search_url + k.split(/\s/).first}\"" }.join(",").html_safe %> ],
		legendpos: "east"
	});
<% else %>
	document.getElementById("service_chart").innerHTML = "No service data";
<% end %>

<%
	hours = 24
	secs  = 300

	stime  = Time.now.to_i
	events = @workspace.events.where('created_at > ?', Time.at(stime - (3600 * hours)).utc )

	timeline = []
	axis     = []

	1.upto( (hours * 3600) / secs).each do |i|
		timeline[i-1] = 0
		axis[i-1]     = i
	end

	events.each do |evt|
		age = ((stime - evt.created_at.to_i) / secs).to_i
		timeline[age]||= 0
		timeline[age] += 1
	end

%>
r = Raphael(document.getElementById("activity_chart"), 400, 140);
var act_x = [<%= axis.map{|x| x.to_i.to_s}.join(",").html_safe %>];
var act_y = [<%= timeline.reverse.map{|x| x.to_i.to_s}.join(",").html_safe %>];
r.g.linechart(0, 0, 400, 100, act_x, act_y, {nostroke: false, axis: "0 0 0 0", smooth: true});

});
</script>

